<template>
  <div class="detail_contain">
    <p class="now_page_title">
      {{$route.name =='organizationuser'?'权限管理  /  组织管理  /  组织详情  /':'权限管理  /  用户管理  /' }}  
      <span>{{$route.name =='organizationuser'?'用户管理':$route.name =='usersadd'?'新增用户':'用户详情'}}</span>
    </p>
    <div class="info_contain">
      <el-form ref="form" :rules="rules" :model="form" label-width="0px">
        <el-form-item prop="account">
          <p class="formname">用户账号：</p>
          <el-input v-model="form.account"></el-input>
        </el-form-item>
        <el-form-item prop="password" :class="{'shortpass':edit_flag}">
          <p class="formname">登录密码：</p>
          <el-input v-model="form.password" :disabled="tranform_flag(edit_flag)"></el-input>
          <div v-if="edit_flag" class="fixpass" @click="change_pass()">修改密码</div>
        </el-form-item>
        <el-form-item prop="nickname">
          <p class="formname">昵称：</p>
          <el-input v-model="form.nickname"></el-input>
        </el-form-item>
        <el-form-item prop="type">
          <p class="formname">用户类型：</p>
          <el-select v-model="form.type" placeholder="请选择">
            <el-option
                v-for="item in typeoptions"
                :key="item.value"
                :label="item.label"
                :value="item.value">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item prop="systemname">
          <p class="formname">业务系统名称：</p>
          <el-input v-model="form.systemname"></el-input>
        </el-form-item>
        <el-form-item prop="domain">
          <p class="formname">域名：</p>
          <el-input v-model="form.domain"></el-input>
        </el-form-item>
        <el-form-item prop="ip">
          <p class="formname">IP白名单：</p>
          <el-input v-model="form.ip"></el-input>
        </el-form-item>
        <el-form-item prop="contact">
          <p class="formname">联系人：</p>
          <el-input v-model="form.contact"></el-input>
        </el-form-item>
        <el-form-item prop="phone">
          <p class="formname">手机号码：</p>
          <el-input v-model="form.phone"></el-input>
        </el-form-item>
        <el-form-item prop="email">
          <p class="formname">邮箱：</p>
          <el-input v-model="form.email"></el-input>
        </el-form-item>
        <el-form-item prop="origin">
          <p class="formname">用户组织机构：</p>
          <el-select v-model="form.origin" placeholder="请选择">
            <el-option
                v-for="item in originoptions"
                :key="item.value+100"
                :label="item.label"
                :value="item.value">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item prop="able">
          <p class="formname">是否禁用：</p>
          <el-select v-model="form.able" placeholder="请选择">
            <el-option
                v-for="item in ableoptions"
                :key="item.value+200"
                :label="item.label"
                :value="item.value">
            </el-option>
          </el-select>
        </el-form-item>

        <el-form-item prop="desc">
          <p class="formname">描述：</p>
          <el-input type="textarea" v-model="form.desc"></el-input>
        </el-form-item>

        <el-form-item prop="person">
          <p class="formname">登记人：</p>
          <el-input v-model="form.person" disabled></el-input>
        </el-form-item>

        <el-form-item prop="date">
          <p class="formname">登记日期：</p>
          <el-input v-model="form.date" disabled></el-input>
        </el-form-item>
        
        <el-form-item>
          <el-button @click="resetForm('form')" class="left" v-if="$route.name =='usersadd'">重置</el-button>
          <el-button type="primary" @click="onSubmit('form')" class="right">保存</el-button>
          <el-button class="right" @click="backPage">取消</el-button>
        </el-form-item>
      </el-form>

      
    </div> 

  </div>
</template>

<script>
import uploadFile from '@/components/upload_file'
import { getRole } from "@/utils/common";
export default {
  props: {},
  components: {
    uploadFile,
  },
  data() {
    var checkip = (rule, value, callback) => {
      var reg = /(((2(5[0-5]|[0-4]\d))|[0-1]?\d{1,2})(\.((2(5[0-5]|[0-4]\d))|[0-1]?\d{1,2})){3});/g
        setTimeout(() => {
          if (!reg.test(value)) {
            callback(new Error('请使用;隔开ip地址'));
          } else {
            callback();
          }
        }, 1000);
      };
    return {
        form: {
          account:'',
          password:'',
          nickname:'',
          type:'',
          systemname:'',
          contact:'',
          phone:'',
          email:'',
          origin:'',
          able:'',
          desc:'',
          person:'',
          date:'',
          ip:'',
          domain:''
        },
        now_user: 0, //0：普通用户，1：组织管理员，2：超级管理员
        typeoptions:[
          {
            label:'普通用户',
            value:3,
          },
          {
            label:'组织管理员',
            value:2,
          },
          {
            label:'超级管理员',
            value:1,
          },
          {
            label:'开发者',
            value:4,
          }
        ],
        originoptions:[
            {
                label:'贵阳水利局',
                value:0,
            },
            {
                label:'云上贵州',
                value:1,
            },
            {
                label:'迪艾斯',
                value:2,
            },
        ],
        ableoptions:[
            {
                label:'是',
                value:0,
            },
            {
                label:'否',
                value:1,
            },
        ],
        origin_arr:[],
        rules:{
          able:[
              { required: true, message: '请选择是否禁用', trigger: 'change' }
          ],
          // domain:[
          //     { required: true, message: '请输入域名', trigger: 'blur' }
          // ],
          ip:[
              // { required: true, message: '请输入ip地址', trigger: 'blur' }
          ],
        },
        edit_flag:0,
    };
  },
  watch: {},
  computed: {},
  created() {
    this.getOriginArr()
    this.get_now_page()
  },
  mounted() {},
  methods: {
     get_now_page(){
        console.log(this.$route);
        if(this.$route.path.indexOf('add')!==-1){
            this.edit_flag = 0 
        }
        if(this.$route.path.indexOf('edit')!==-1){
            this.edit_flag = 1
            this.get_user()
        }
        if(this.$route.path.indexOf('detail')!==-1){
            this.edit_flag = 2
            this.get_user()
        }
        
    },
    tranform_flag(val){
      return val?true:false
    },
    change_pass(){
      this.$http
            .put(`/apaas/backmgt/user/initalPasswd/${this.$route.params.id}`)
            .then(response => {
                console.log(response);
                this.$message.success('修改成默认密码成功 默认密码：123456')
            })
            .catch((response)=> {
                
            });
    },
     get_user(){
        this.$http
            .get(`/apaas/backmgt/user/detail/${this.$route.params.id}`)
            .then(response => {
                console.log(response);
                let data = response.data.data
                this.form={
                  account:data.user_id,
                  password:'******',
                  nickname:data.user_name,
                  type:data.is_admin,
                  systemname:data.system_name,
                  contact:data.link_man,
                  phone:data.phone,
                  email:data.email,
                  origin:data.department_id,
                  able:data.state,
                  desc:data.description,
                  person:data.create_user,
                  date:data.create_date,
                  ip:data.ip_whitelist,
                  domain:data.domain_name
                }
            })
            .catch((response)=> {
                
            });
    },
    getOriginArr(){
      this.originoptions = []
      this.$http
            .get('/apaas/backmgt/department/list')
            .then(response => {
                let data = response.data.data
                // this.originoptions = data
                data.forEach(e => {
                  this.originoptions.push({
                    label:e.department_name,
                    value:e.department_id
                  })
                });
            })
            .catch(function(response) {
                
            });
    },
    removepic(){
      this.$refs.servicepic.handleRemove()
    },
    backPage(){
        this.$router.back(-1)
    },
    add_user(){
      var temp = {
        "user_id":this.form.account,   // 用户名
        "user_name":this.form.nickname,  // 昵称
        "system_name":this.form.systemname,//系统名称
        "phone":this.form.phone,  // 电话号
        "email":this.form.email, // 邮箱
        "department_id":this.form.origin, // 组织id
        "is_admin":this.form.type,
        "state":this.form.able,  // 用户状态，1——启用，0 禁用
        "domain_name":this.form.domain,//
        "ip_whitelist":this.form.ip.split(';'),//
        "description":this.form.desc, //描述
        "link_man":this.form.contact
      }
          this.$http
            .post(`/apaas/backmgt/user/register`,temp)
            .then(response => {
                console.log(response);
                this.backPage()
                this.$message.success('新增成功')
            })
            .catch((response)=> {
                this.$message.error('新增失败')
            });
    },
    set_user(){
      var temp = {
        "user_id":this.form.account,   // 用户名
        "user_name":this.form.nickname,  // 昵称
        "system_name":this.form.systemname,//系统名称
        "phone":this.form.phone,  // 电话号
        "email":this.form.email, // 邮箱
        "department_id":this.form.origin, // 组织id
        "is_admin":this.form.type,
        "state":this.form.able,  // 用户状态，1——启用，0 禁用
        "domain_name":this.form.domain,//
        "ip_whitelist":this.form.ip.split(';'),//
        "description":this.form.desc, //描述
        "link_man":this.form.contact
      }
          this.$http
            .put(`/apaas/backmgt/user/put`,temp)
            .then(response => {
                console.log(response);
                this.backPage()
                this.$message.success('修改成功')
            })
            .catch((response)=> {
                this.$message.error('修改失败')
            });
    },
      onSubmit(formName) {
        console.log('submit!');
        this.$refs[formName].validate((valid) => {
          if (valid) {
            if(this.edit_flag == 0){
                this.add_user()
              }else{
                this.set_user()
              }
              
          } else {
            console.log('error submit!!');
            return false;
          }
        });
      },
      resetForm(formName) {
        this.$refs[formName].resetFields();
      }
  }
};
</script>


<style>
.info_contain .el-input__inner{
  background-color: #f7f8f9;
  width: 1022px;
}
.shortpass .el-input__inner{
  background-color: #f7f8f9;
  width: 888px;
}
.shortpass .el-input{
  width: 888px;
}
.info_contain .el-textarea__inner{
  background-color: #f7f8f9;
  width: 1022px;
}
.limitsd .timeslect .el-input__inner{
  width: 150px;
  border-radius: 0 8px 8px 0;
  background-color: rgba(15, 38, 131, 1);
  color: rgba(248, 249, 253, 1);
  border: 0;
}
.info_contain .el-input.is-disabled .el-input__inner{
    background-color: #e3e4e6;
}
</style>

<style scoped>
.detail_contain {
  width: 100%;
  padding: 0 20px;
  height: calc(100% - 55px);
}
.info_contain {
  padding: 25px 20px;
  background-color: #fff;
  width: 100%;
  box-shadow: 0px 3px 6px 0px #f4f7fc;
  border-radius: 12px;
  min-height: calc(100% - 20px);
    margin-bottom: 20px;
    position: relative;
}
.now_page_title {
  margin: 15px 0;
  color: #898d9e;
}
.now_page_title span {
  color: #242c43;
}
.formname{
  color: #58617a;
}
.right{
  float: right;
  margin-left: 20px;
}
.left{
  float: left;
}
.removepic{
  display: inline-block;
  margin-top: -40px;
  float: left;
  margin-left: 180px;
  width: 76px;
  height: 32px;
  background-color: #495feb;
  border-radius: 8px;
  line-height: 32px;
  text-align: center;
  color: #e6ebfe;
  cursor: pointer;
}
.edit_change{
  width: 100%;
  border-bottom: 2px solid #f4f7fc;
  overflow: hidden;
}
.edit_change_box{
  width: 163px;
  height: 48px;
  line-height: 48px;
	background-color: #e3e5ef;
  border-radius: 8px;
  color: #8890a7;
  text-align: center;
  float: left;
  margin-right: 20px;
  font-weight: 600;
  margin-bottom: 25px;
  font-size: 16px;
  cursor: pointer;
}
.edit_change_box img{
  vertical-align: -3px;
  margin-right: 5px;
}
.safe_title{
    width: 100%;
    height: 65px;
    line-height: 65px;
    border-bottom: 2px solid #f4f7fc;
}
.safe_select{
    float: left;
    width: auto;
    margin-right: 40px;
    height: 65px;
    cursor: pointer;
}
.safe_box_select{
    padding: 30px 10px 10px 10px;
    width: 100%;
    height: 100%;
}
.openbgc{
  width: 56px;
	height: 23px;
  background-image: url('~@/assets/imgs/btn_on_hov.png');
  background-size:contain;
  cursor: pointer;
}
.formtitle{
  color: #58617a;
  margin: 15px 0;
}

.savebtn{
  position: absolute;
  right: 20px;
  bottom:20px;
  width: 278px;
  overflow: hidden;
}
.btnsty{
  width: 124px;
	height: 44px;
  line-height: 44px;
	background-color: rgba(195, 202, 248, 0.5);
	border-radius: 8px;
  color: rgba(15, 38, 131, 1);
  text-align: center;
  float: left;
  margin-right: 30px;
  cursor: pointer;
}
.savebtn .btnsty:nth-last-of-type(1){
  margin-right: 0px;
  background-color: rgba(15, 38, 131, 1);
  color: rgba(248, 249, 253, 1);
}
.limitsd{
  position: relative;
  width: 1022px;
}
.limitsd .timeslect{
  position: absolute;
  right: 0;
}
.fixpass{
  width: 124px;
	height: 44px;
  line-height: 44px;
  text-align: center;
  font-size: 16px;
  color: #fff;
	background-color: #495feb;
	border-radius: 8px;
  display: inline-block;
  margin-left: 5px;
  cursor: pointer;
}
</style>
